Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p5zlim.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p5zlim.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p5zlim.F90	(revision 10425)
@@ -535,5 +535,5 @@
       !!                     ***  ROUTINE p5z_lim_alloc  ***
       !!----------------------------------------------------------------------
-      USE lib_mpp , ONLY: ctl_warn
+      USE lib_mpp , ONLY: ctl_stop
       INTEGER ::   ierr(2)        ! Local variables
       !!----------------------------------------------------------------------
@@ -559,5 +559,5 @@
       p5z_lim_alloc = MAXVAL( ierr )
       !
-      IF( p5z_lim_alloc /= 0 ) CALL ctl_warn('p5z_lim_alloc : failed to allocate arrays.')
+      IF( p5z_lim_alloc /= 0 ) CALL ctl_stop( 'STOP', 'p5z_lim_alloc : failed to allocate arrays.' )
       !
    END FUNCTION p5z_lim_alloc
Index: /NEMO/trunk/src/TOP/PISCES/P4Z/p5zprod.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/P4Z/p5zprod.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/P4Z/p5zprod.F90	(revision 10425)
@@ -462,5 +462,5 @@
     ! Total primary production per year
     IF( iom_use( "tintpp" ) .OR. ( ln_check_mass .AND. kt == nitend .AND. knt == nrdttrc )  )  &
-      & tpp = glob_sum( ( zprorcan(:,:,:) + zprorcad(:,:,:) + zprorcap(:,:,:) ) * cvol(:,:,:) )
+      & tpp = glob_sum( 'p5zprod', ( zprorcan(:,:,:) + zprorcad(:,:,:) + zprorcap(:,:,:) ) * cvol(:,:,:) )
 
     IF( lk_iomput ) THEN
@@ -624,5 +624,5 @@
       ALLOCATE( zdaylen(jpi,jpj), STAT = p5z_prod_alloc )
       !
-      IF( p5z_prod_alloc /= 0 ) CALL ctl_warn('p5z_prod_alloc : failed to allocate arrays.')
+      IF( p5z_prod_alloc /= 0 ) CALL ctl_stop( 'STOP', 'p5z_prod_alloc : failed to allocate arrays.' )
       !
    END FUNCTION p5z_prod_alloc
Index: /NEMO/trunk/src/TOP/PISCES/SED/sed.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/SED/sed.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/SED/sed.F90	(revision 10425)
@@ -154,5 +154,5 @@
       !!                    *** ROUTINE sed_alloc ***
       !!-------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_stop
       !!-------------------------------------------------------------------
       !
@@ -166,5 +166,5 @@
          &      mol_wgt(jpsol),                                           STAT=sed_alloc )
 
-      IF( sed_alloc /= 0 )   CALL ctl_warn('sed_alloc: failed to allocate arrays')
+      IF( sed_alloc /= 0 )   CALL ctl_stop( 'STOP', 'sed_alloc: failed to allocate arrays' )
       !
    END FUNCTION sed_alloc
Index: /NEMO/trunk/src/TOP/PISCES/SED/sed_oce.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/SED/sed_oce.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/SED/sed_oce.F90	(revision 10425)
@@ -25,10 +25,10 @@
       !!                    *** ROUTINE sed_alloc ***
       !!-------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_stop
       !!-------------------------------------------------------------------
       !
       ALLOCATE( profsed(jpksed) , profsedw(jpksed) , STAT=sed_oce_alloc )
 
-      IF( sed_oce_alloc /= 0 )   CALL ctl_warn('sed_oce_alloc: failed to allocate arrays')
+      IF( sed_oce_alloc /= 0 )   CALL ctl_stop( 'STOP', 'sed_oce_alloc: failed to allocate arrays' )
       !
    END FUNCTION sed_oce_alloc
Index: /NEMO/trunk/src/TOP/PISCES/SED/sedadv.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/SED/sedadv.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/SED/sedadv.F90	(revision 10425)
@@ -436,5 +436,5 @@
       &         ckpor(jpksed) ,           STAT = sed_adv_alloc )
       !
-      IF( sed_adv_alloc /= 0 ) CALL ctl_warn('sed_adv_alloc : failed to allocate arrays.')
+      IF( sed_adv_alloc /= 0 ) CALL ctl_stop( 'STOP', 'sed_adv_alloc : failed to allocate arrays.' )
       !
    END FUNCTION sed_adv_alloc
Index: /NEMO/trunk/src/TOP/PISCES/SED/sedrst.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/SED/sedrst.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/SED/sedrst.F90	(revision 10425)
@@ -78,5 +78,5 @@
          IF(lwp) WRITE(numsed,*) &
              '             open sed restart.output NetCDF file: ',TRIM(clpath)//clname
-         CALL iom_open( TRIM(clpath)//TRIM(clname), numrsw, ldwrt = .TRUE., kiolib = jprstlib, kdlev = jpksed )
+         CALL iom_open( TRIM(clpath)//TRIM(clname), numrsw, ldwrt = .TRUE., kdlev = jpksed )
          lrst_sed = .TRUE.
       ENDIF
@@ -105,5 +105,4 @@
       CHARACTER(len = 20) ::   cltra
       CHARACTER(LEN=20)   ::   name1
-      INTEGER             ::   jlibalt = jprstlib
       LOGICAL             ::   llok
       !--------------------------------------------------------------------
@@ -338,5 +337,4 @@
       CHARACTER(len=*), INTENT(in) ::   cdrw       ! "READ"/"WRITE" flag
       !
-      INTEGER  ::  jlibalt = jprstlib
       LOGICAL  ::  llok
       REAL(wp) ::  zkt, zrdttrc1
@@ -353,5 +351,5 @@
 
          IF( ln_rst_sed ) THEN
-            CALL iom_open( TRIM(cn_sedrst_indir)//'/'//cn_sedrst_in, numrsr, kiolib = jlibalt )
+            CALL iom_open( TRIM(cn_sedrst_indir)//'/'//cn_sedrst_in, numrsr )
             CALL iom_get ( numrsr, 'kt', zkt )   ! last time-step of previous run
 
Index: /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/sms_pisces.F90	(revision 10425)
@@ -131,5 +131,5 @@
       !!        *** ROUTINE sms_pisces_alloc ***
       !!----------------------------------------------------------------------
-      USE lib_mpp , ONLY: ctl_warn
+      USE lib_mpp , ONLY: ctl_stop
       INTEGER ::   ierr(10)        ! Local variables
       !!----------------------------------------------------------------------
@@ -186,5 +186,5 @@
       sms_pisces_alloc = MAXVAL( ierr )
       !
-      IF( sms_pisces_alloc /= 0 )   CALL ctl_warn('sms_pisces_alloc: failed to allocate arrays') 
+      IF( sms_pisces_alloc /= 0 )   CALL ctl_stop( 'STOP', 'sms_pisces_alloc: failed to allocate arrays' ) 
       !
    END FUNCTION sms_pisces_alloc
Index: /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90
===================================================================
--- /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/PISCES/trcini_pisces.F90	(revision 10425)
@@ -118,5 +118,5 @@
       ierr = ierr +  p4z_rem_alloc()
       !
-      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      CALL mpp_sum( 'trcini_pisces', ierr )
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'pisces_alloc: unable to allocate PISCES arrays' )
       !
@@ -311,5 +311,5 @@
       ierr = ierr + p2z_exp_alloc()
       !
-      IF( lk_mpp    )   CALL mpp_sum( ierr )
+      CALL mpp_sum( 'trcini_pisces', ierr )
       IF( ierr /= 0 )   CALL ctl_stop( 'STOP', 'p2z_ini: unable to allocate LOBSTER arrays' )
 
Index: /NEMO/trunk/src/TOP/TRP/trcnxt.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trcnxt.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trcnxt.F90	(revision 10425)
@@ -97,5 +97,5 @@
 #endif
       ! Update after tracer on domain lateral boundaries
-      CALL lbc_lnk( tra(:,:,:,:), 'T', 1. )   
+      CALL lbc_lnk( 'trcnxt', tra(:,:,:,:), 'T', 1. )   
 
       IF( ln_bdy )  CALL trc_bdy( kt )
@@ -164,5 +164,5 @@
          ENDIF
          !
-         CALL lbc_lnk_multi( trb(:,:,:,:), 'T', 1._wp, trn(:,:,:,:), 'T', 1._wp, tra(:,:,:,:), 'T', 1._wp )
+         CALL lbc_lnk_multi( 'trcnxt', trb(:,:,:,:), 'T', 1._wp, trn(:,:,:,:), 'T', 1._wp, tra(:,:,:,:), 'T', 1._wp )
       ENDIF
       !
Index: /NEMO/trunk/src/TOP/TRP/trcrad.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trcrad.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trcrad.F90	(revision 10425)
@@ -19,4 +19,5 @@
    USE trdtra
    USE prtctl_trc          ! Print control for debbuging
+   USE lib_fortran
 
    IMPLICIT NONE
@@ -27,4 +28,5 @@
 
    LOGICAL , PUBLIC ::   ln_trcrad           !: flag to artificially correct negative concentrations
+   REAL(wp), DIMENSION(:,:), ALLOCATABLE::   gainmass
 
    !!----------------------------------------------------------------------
@@ -104,4 +106,7 @@
          ENDIF
       ENDIF
+      !
+      ALLOCATE( gainmass(jptra,2) )
+      gainmass(:,:) = 0.
       !
    END SUBROUTINE trc_rad_ini
@@ -129,73 +134,47 @@
       CHARACTER( len = 1), OPTIONAL          , INTENT(in   ) ::   cpreserv           ! flag to preserve content or not
       !
-      INTEGER ::   ji, jj, jk, jn     ! dummy loop indices
-      LOGICAL ::   lldebug = .FALSE.           ! local logical
-      REAL(wp)::   ztrcorb, ztrmasb, zs2rdt    ! temporary scalars
-      REAL(wp)::   zcoef  , ztrcorn, ztrmasn   !    -         -
-      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrtrdb, ztrtrdn   ! workspace arrays
-      !!----------------------------------------------------------------------
-      !
-      IF( l_trdtrc )   ALLOCATE( ztrtrdb(jpi,jpj,jpk), ztrtrdn(jpi,jpj,jpk) )
+      INTEGER ::   ji, ji2, jj, jj2, jk, jn     ! dummy loop indices
+      INTEGER ::   icnt
+      LOGICAL ::   lldebug = .FALSE.            ! local logical
+      REAL(wp)::   zcoef, zs2rdt, ztotmass
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrneg, ztrpos
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::   ztrtrd   ! workspace arrays
+      !!----------------------------------------------------------------------
+      !
+      IF( l_trdtrc )   ALLOCATE( ztrtrd(jpi,jpj,jpk) )
+      zs2rdt = 1. / ( 2. * rdt * REAL( nn_dttrc, wp ) )
       !
       IF( PRESENT( cpreserv )  ) THEN     !==  total tracer concentration is preserved  ==!
          !
-         DO jn = jp_sms0, jp_sms1
-            !
-            ztrcorb = 0._wp   ;   ztrmasb = 0._wp
-            ztrcorn = 0._wp   ;   ztrmasn = 0._wp
-            !
-            IF( l_trdtrc ) THEN
-               ztrtrdb(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
-               ztrtrdn(:,:,:) = ptrn(:,:,:,jn)                        ! save input trn for trend computation
-            ENDIF
-            !                                                         ! sum over the global domain 
-            ztrcorb = glob_sum( MIN( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:) )
-            ztrcorn = glob_sum( MIN( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:) )
-            !
-            ztrmasb = glob_sum( MAX( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:) )
-            ztrmasn = glob_sum( MAX( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:) )
-            !
-            IF( ztrcorb /= 0 ) THEN
-               zcoef = 1. + ztrcorb / ztrmasb
-               DO jk = 1, jpkm1
-                  ptrb(:,:,jk,jn) = MAX( 0., ptrb(:,:,jk,jn) )
-                  ptrb(:,:,jk,jn) = ptrb(:,:,jk,jn) * zcoef * tmask(:,:,jk)
-               END DO
-            ENDIF
-            !
-            IF( ztrcorn /= 0 ) THEN
-               zcoef = 1. + ztrcorn / ztrmasn
-               DO jk = 1, jpkm1
-                  ptrn(:,:,jk,jn) = MAX( 0., ptrn(:,:,jk,jn) )
-                  ptrn(:,:,jk,jn) = ptrn(:,:,jk,jn) * zcoef * tmask(:,:,jk)
-               END DO
-            ENDIF
-            !
-            IF( l_trdtrc ) THEN
-               !
-               zs2rdt = 1. / ( 2. * rdt )
-               ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
-               ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
-               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
-              !
-            ENDIF
-            !
-         END DO
-         !
-      ELSE                                !==  total CFC content is NOT strictly preserved  ==!
-         !
-         DO jn = jp_sms0, jp_sms1  
-            !
-            IF( l_trdtrc ) THEN
-               ztrtrdb(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
-               ztrtrdn(:,:,:) = ptrn(:,:,:,jn)                        ! save input trn for trend computation
-            ENDIF
+         ALLOCATE( ztrneg(1:jpi,1:jpj,jp_sms0:jp_sms1), ztrpos(1:jpi,1:jpj,jp_sms0:jp_sms1) )
+
+         DO jn = jp_sms0, jp_sms1
+            ztrneg(:,:,jn) = SUM( MIN( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:), dim = 3 )   ! sum of the negative values
+            ztrpos(:,:,jn) = SUM( MAX( 0., ptrb(:,:,:,jn) ) * cvol(:,:,:), dim = 3 )   ! sum of the positive values
+         END DO
+         CALL sum3x3( ztrneg )
+         CALL sum3x3( ztrpos )
+         
+         DO jn = jp_sms0, jp_sms1
+            !
+            IF( l_trdtrc )   ztrtrd(:,:,:) = ptrb(:,:,:,jn)                            ! save input trb for trend computation           
             !
             DO jk = 1, jpkm1
                DO jj = 1, jpj
                   DO ji = 1, jpi
-                     ptrn(ji,jj,jk,jn) = MAX( 0. , ptrn(ji,jj,jk,jn) )
-                     ptrb(ji,jj,jk,jn) = MAX( 0. , ptrb(ji,jj,jk,jn) )
+                     IF( ztrneg(ji,jj,jn) /= 0. ) THEN                                 ! if negative values over the 3x3 box
+                        !
+                        ptrb(ji,jj,jk,jn) = ptrb(ji,jj,jk,jn) * tmask(ji,jj,jk)   ! really needed?
+                        IF( ptrb(ji,jj,jk,jn) < 0. ) ptrb(ji,jj,jk,jn) = 0.       ! supress negative values
+                        IF( ptrb(ji,jj,jk,jn) > 0. ) THEN                         ! use positive values to compensate mass gain
+                           zcoef = 1. + ztrneg(ji,jj,jn) / ztrpos(ji,jj,jn)       ! ztrpos > 0 as ptrb > 0
+                           ptrb(ji,jj,jk,jn) = ptrb(ji,jj,jk,jn) * zcoef
+                           IF( zcoef < 0. ) THEN                                  ! if the compensation exceed the positive value
+                              gainmass(jn,1) = gainmass(jn,1) - ptrb(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
+                              ptrb(ji,jj,jk,jn) = 0.                              ! limit the compensation to keep positive value
+                           ENDIF
+                        ENDIF
+                        !
+                     ENDIF
                   END DO
                END DO
@@ -203,11 +182,93 @@
             !
             IF( l_trdtrc ) THEN
-               !
-               zs2rdt = 1. / ( 2. * rdt * REAL( nn_dttrc, wp ) )
-               ztrtrdb(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrdb(:,:,:) ) * zs2rdt
-               ztrtrdn(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrdn(:,:,:) ) * zs2rdt 
-               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrdb )       ! Asselin-like trend handling
-               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrdn )       ! standard     trend handling
-              !
+               ztrtrd(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrd(:,:,:) ) * zs2rdt
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrd )       ! Asselin-like trend handling
+            ENDIF
+            !
+         END DO
+ 
+         IF( kt == nitend ) THEN
+            CALL mpp_sum( 'trcrad', gainmass(:,1) )
+            DO jn = jp_sms0, jp_sms1
+               IF( gainmass(jn,1) > 0. ) THEN
+                  ztotmass = glob_sum( 'trcrad', ptrb(:,:,:,jn) * cvol(:,:,:) )
+                  IF(lwp) WRITE(numout, '(a, i2, a, D23.16, a, D23.16)') 'trcrad ptrb, traceur ', jn  &
+                     &        , ' total mass : ', ztotmass, ', mass gain : ',  gainmass(jn,1)
+               END IF
+            END DO
+         ENDIF
+
+         DO jn = jp_sms0, jp_sms1
+            ztrneg(:,:,jn) = SUM( MIN( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:), dim = 3 )   ! sum of the negative values
+            ztrpos(:,:,jn) = SUM( MAX( 0., ptrn(:,:,:,jn) ) * cvol(:,:,:), dim = 3 )   ! sum of the positive values
+         END DO
+         CALL sum3x3( ztrneg )
+         CALL sum3x3( ztrpos )
+         
+         DO jn = jp_sms0, jp_sms1
+            !
+            IF( l_trdtrc )   ztrtrd(:,:,:) = ptrn(:,:,:,jn)                            ! save input trb for trend computation
+            !
+            DO jk = 1, jpkm1
+               DO jj = 1, jpj
+                  DO ji = 1, jpi
+                     IF( ztrneg(ji,jj,jn) /= 0. ) THEN                                 ! if negative values over the 3x3 box
+                        !
+                        ptrn(ji,jj,jk,jn) = ptrn(ji,jj,jk,jn) * tmask(ji,jj,jk)   ! really needed?
+                        IF( ptrn(ji,jj,jk,jn) < 0. ) ptrn(ji,jj,jk,jn) = 0.       ! supress negative values
+                        IF( ptrn(ji,jj,jk,jn) > 0. ) THEN                         ! use positive values to compensate mass gain
+                           zcoef = 1. + ztrneg(ji,jj,jn) / ztrpos(ji,jj,jn)       ! ztrpos > 0 as ptrb > 0
+                           ptrn(ji,jj,jk,jn) = ptrn(ji,jj,jk,jn) * zcoef
+                           IF( zcoef < 0. ) THEN                                  ! if the compensation exceed the positive value
+                              gainmass(jn,2) = gainmass(jn,2) - ptrn(ji,jj,jk,jn) * cvol(ji,jj,jk)   ! we are adding mass...
+                              ptrn(ji,jj,jk,jn) = 0.                              ! limit the compensation to keep positive value
+                           ENDIF
+                        ENDIF
+                        !
+                     ENDIF
+                  END DO
+               END DO
+            END DO
+            !
+            IF( l_trdtrc ) THEN
+               ztrtrd(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrd(:,:,:) ) * zs2rdt
+               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrd )       ! standard     trend handling
+            ENDIF
+            !
+         END DO
+ 
+         IF( kt == nitend ) THEN
+            CALL mpp_sum( 'trcrad', gainmass(:,2) )
+            DO jn = jp_sms0, jp_sms1
+               IF( gainmass(jn,2) > 0. ) THEN
+                  ztotmass = glob_sum( 'trcrad', ptrn(:,:,:,jn) * cvol(:,:,:) )
+                  WRITE(numout, '(a, i2, a, D23.16, a, D23.16)') 'trcrad ptrn, traceur ', jn  &
+                     &        , ' total mass : ', ztotmass, ', mass gain : ',  gainmass(jn,1)
+               END IF
+            END DO
+         ENDIF
+
+         DEALLOCATE( ztrneg, ztrpos )
+         !
+      ELSE                                !==  total CFC content is NOT strictly preserved  ==!
+         !
+         DO jn = jp_sms0, jp_sms1  
+            !
+            IF( l_trdtrc )   ztrtrd(:,:,:) = ptrb(:,:,:,jn)                        ! save input trb for trend computation
+            !
+            WHERE( ptrb(:,:,:,jn) < 0. )   ptrb(:,:,:,jn) = 0.
+            !
+            IF( l_trdtrc ) THEN
+               ztrtrd(:,:,:) = ( ptrb(:,:,:,jn) - ztrtrd(:,:,:) ) * zs2rdt
+               CALL trd_tra( kt, 'TRC', jn, jptra_radb, ztrtrd )       ! Asselin-like trend handling
+            ENDIF
+            !
+            IF( l_trdtrc )   ztrtrd(:,:,:) = ptrn(:,:,:,jn)                        ! save input trn for trend computation
+            !
+            WHERE( ptrn(:,:,:,jn) < 0. )   ptrn(:,:,:,jn) = 0.
+            !
+            IF( l_trdtrc ) THEN
+               ztrtrd(:,:,:) = ( ptrn(:,:,:,jn) - ztrtrd(:,:,:) ) * zs2rdt
+               CALL trd_tra( kt, 'TRC', jn, jptra_radn, ztrtrd )       ! standard     trend handling
             ENDIF
             !
@@ -216,5 +277,5 @@
       ENDIF
       !
-      IF( l_trdtrc )  DEALLOCATE( ztrtrdb, ztrtrdn )
+      IF( l_trdtrc )  DEALLOCATE( ztrtrd )
       !
    END SUBROUTINE trc_rad_sms
Index: /NEMO/trunk/src/TOP/TRP/trcsbc.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trcsbc.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trcsbc.F90	(revision 10425)
@@ -113,9 +113,7 @@
 
       ! 0. initialization
-      DO jn = 1, jptra
-         !
-         IF( l_trdtrc )   ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
-         !
-         IF( nn_ice_tr == -1 ) THEN    ! No tracers in sea ice (null concentration in sea ice)
+      IF( nn_ice_tr == -1 ) THEN    ! No tracers in sea ice (null concentration in sea ice)
+         !
+         DO jn = 1, jptra
             DO jj = 2, jpj
                DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -123,5 +121,9 @@
                END DO
             END DO
-         ELSE
+         END DO
+         !
+       ELSE
+         !
+         DO jn = 1, jptra
             DO jj = 2, jpj
                DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -143,8 +145,13 @@
                END DO
             END DO
-         ENDIF
-         !
-         CALL lbc_lnk( sbc_trc(:,:,jn), 'T', 1. )
-         !                                       Concentration dilution effect on tracers due to evaporation & precipitation 
+         END DO
+      ENDIF
+      !
+      CALL lbc_lnk( 'trcsbc', sbc_trc(:,:,:), 'T', 1. )
+      !                                       Concentration dilution effect on tracers due to evaporation & precipitation 
+      DO jn = 1, jptra
+         !
+         IF( l_trdtrc )   ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
+         !
          DO jj = 2, jpj
             DO ji = fs_2, fs_jpim1   ! vector opt.
Index: /NEMO/trunk/src/TOP/TRP/trdmxl_trc.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trdmxl_trc.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trdmxl_trc.F90	(revision 10425)
@@ -64,6 +64,6 @@
          &      ndextrd1(jpi*jpj), nidtrd(jptra), nh_t(jptra),  STAT=trd_mxl_trc_alloc)
          !
-      IF( lk_mpp                )   CALL mpp_sum ( trd_mxl_trc_alloc )
-      IF( trd_mxl_trc_alloc /=0 )   CALL ctl_warn('trd_mxl_trc_alloc: failed to allocate arrays')
+      CALL mpp_sum ( 'trdmxl_trc', trd_mxl_trc_alloc )
+      IF( trd_mxl_trc_alloc /=0 )   CALL ctl_stop( 'STOP', 'trd_mxl_trc_alloc: failed to allocate arrays' )
       !
    END FUNCTION trd_mxl_trc_alloc
@@ -290,5 +290,5 @@
             IF( ln_trdtrc(jn) ) THEN
                DO jl = 1, jpltrd_trc
-                  CALL lbc_lnk( tmltrd_trc(:,:,jl,jn), 'T', 1. )        ! lateral boundary conditions
+                  CALL lbc_lnk( 'trdmxl_trc', tmltrd_trc(:,:,jl,jn), 'T', 1. )        ! lateral boundary conditions
                END DO
             ENDIF
@@ -425,5 +425,5 @@
          !-- Lateral boundary conditions
                IF ( cn_cfg .NE. 'gyre' ) THEN
-                  CALL lbc_lnk_multi( ztmltot(:,:,jn) , 'T', 1. , ztmlres(:,:,jn) , 'T', 1., &
+                  CALL lbc_lnk_multi( 'trdmxl_trc', ztmltot(:,:,jn) , 'T', 1. , ztmlres(:,:,jn) , 'T', 1., &
                      &                ztmlatf(:,:,jn) , 'T', 1. , ztmlrad(:,:,jn) , 'T', 1. )
                ENDIF
@@ -476,7 +476,7 @@
          !-- Lateral boundary conditions 
                IF ( cn_cfg .NE. 'gyre' ) THEN            ! other than GYRE configuration    
-                  CALL lbc_lnk_multi( ztmltot2(:,:,jn), 'T', 1., ztmlres2(:,:,jn), 'T', 1. )
+                  CALL lbc_lnk_multi( 'trdmxl_trc', ztmltot2(:,:,jn), 'T', 1., ztmlres2(:,:,jn), 'T', 1. )
                   DO jl = 1, jpltrd_trc
-                     CALL lbc_lnk( ztmltrd2(:,:,jl,jn), 'T', 1. )       ! will be output in the NetCDF trends file
+                     CALL lbc_lnk( 'trdmxl_trc', ztmltrd2(:,:,jl,jn), 'T', 1. )       ! will be output in the NetCDF trends file
                   END DO
                ENDIF
@@ -776,14 +776,13 @@
 
       IF( ( lk_trdmxl_trc ) .AND. ( MOD( nitend-nittrc000+1, nn_trd_trc ) /= 0 ) ) THEN
-         WRITE(numout,cform_err)
-         WRITE(numout,*) '                Your nitend parameter, nitend = ', nitend
-         WRITE(numout,*) '                is no multiple of the trends diagnostics frequency        '
-         WRITE(numout,*) '                          you defined, nn_trd_trc   = ', nn_trd_trc
-         WRITE(numout,*) '                This will not allow you to restart from this simulation.  '
-         WRITE(numout,*) '                You should reconsider this choice.                        ' 
-         WRITE(numout,*) 
-         WRITE(numout,*) '                N.B. the nitend parameter is also constrained to be a     '
-         WRITE(numout,*) '                multiple of the sea-ice frequency parameter (typically 5) '
-         nstop = nstop + 1
+         WRITE(ctmp1,*) '                Your nitend parameter, nitend = ', nitend
+         WRITE(ctmp2,*) '                is no multiple of the trends diagnostics frequency        '
+         WRITE(ctmp3,*) '                          you defined, nn_trd_trc   = ', nn_trd_trc
+         WRITE(ctmp4,*) '                This will not allow you to restart from this simulation.  '
+         WRITE(ctmp5,*) '                You should reconsider this choice.                        ' 
+         WRITE(ctmp6,*) 
+         WRITE(ctmp7,*) '                N.B. the nitend parameter is also constrained to be a     '
+         WRITE(ctmp8,*) '                multiple of the sea-ice frequency parameter (typically 5) '
+         CALL ctl_stop( ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, ctmp7, ctmp8 )
       ENDIF
 
@@ -795,14 +794,12 @@
 
       IF( ( ln_trcadv_muscl .OR. ln_trcadv_muscl2 ) .AND. .NOT. ln_trdmxl_trc_instant ) THEN
-         WRITE(numout,cform_err)
-         WRITE(numout,*) '                Currently, you can NOT use simultaneously tracer MUSCL    '
-         WRITE(numout,*) '                advection and window averaged diagnostics of ML trends.   '
-         WRITE(numout,*) '                WHY? Everything in trdmxl_trc is coded for leap-frog, and '
-         WRITE(numout,*) '                MUSCL scheme is Euler forward for passive tracers (note   '
-         WRITE(numout,*) '                that MUSCL is leap-frog for active tracers T/S).          '
-         WRITE(numout,*) '                In particuliar, entrainment trend would be FALSE. However '
-         WRITE(numout,*) '                this residual is correct for instantaneous ML diagnostics.'
-         WRITE(numout,*) 
-         nstop = nstop + 1
+         WRITE(ctmp1,*) '                Currently, you can NOT use simultaneously tracer MUSCL    '
+         WRITE(ctmp2,*) '                advection and window averaged diagnostics of ML trends.   '
+         WRITE(ctmp3,*) '                WHY? Everything in trdmxl_trc is coded for leap-frog, and '
+         WRITE(ctmp4,*) '                MUSCL scheme is Euler forward for passive tracers (note   '
+         WRITE(ctmp5,*) '                that MUSCL is leap-frog for active tracers T/S).          '
+         WRITE(ctmp6,*) '                In particuliar, entrainment trend would be FALSE. However '
+         WRITE(ctmp7,*) '                this residual is correct for instantaneous ML diagnostics.'
+         CALL ctl_stop( ctmp1, ctmp2, ctmp3, ctmp4, ctmp5, ctmp6, ctmp7 )
       ENDIF
 
Index: /NEMO/trunk/src/TOP/TRP/trdmxl_trc_rst.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trdmxl_trc_rst.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trdmxl_trc_rst.F90	(revision 10425)
@@ -54,5 +54,5 @@
          IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath) // '/'
          IF(lwp) WRITE(numout,*) '             open ocean restart_mld_trc NetCDF  'TRIM(clpath)//TRIM(clname)
-         CALL iom_open( TRIM(clpath)//TRIM(clname), nummldw_trc, ldwrt = .TRUE., kiolib = jprstlib )
+         CALL iom_open( TRIM(clpath)//TRIM(clname), nummldw_trc, ldwrt = .TRUE. )
       ENDIF
 
@@ -127,5 +127,4 @@
       CHARACTER (len=35) :: charout
       INTEGER ::  jk, jn, jl     ! loop indice
-      INTEGER ::  jlibalt = jprstlib
       LOGICAL ::  llok
       CHARACTER(LEN=256)  ::   clpath   ! full path to restart file
@@ -140,5 +139,5 @@
       clpath = TRIM(cn_trcrst_indir)
       IF( clpath(LEN_TRIM(clpath):) /= '/' ) clpath = TRIM(clpath) // '/'
-      CALL iom_open( TRIM(clpath)//TRIM(cn_trdrst_trc_in), inum, kiolib = jlibalt ) 
+      CALL iom_open( TRIM(clpath)//TRIM(cn_trdrst_trc_in), inum ) 
       
       IF( ln_trdmxl_trc_instant ) THEN 
Index: /NEMO/trunk/src/TOP/TRP/trdtrc_oce.F90
===================================================================
--- /NEMO/trunk/src/TOP/TRP/trdtrc_oce.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/TRP/trdtrc_oce.F90	(revision 10425)
@@ -117,5 +117,5 @@
       !!         *** ROUTINE trd_trc_oce_alloc ***
       !!----------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_stop
       INTEGER :: ierr(2)
       !!----------------------------------------------------------------------
@@ -146,5 +146,5 @@
       trd_trc_oce_alloc = MAXVAL(ierr)
       !
-      IF( trd_trc_oce_alloc /= 0 )   CALL ctl_warn('trd_trc_oce_alloc: failed to allocate arrays')
+      IF( trd_trc_oce_alloc /= 0 )   CALL ctl_stop( 'STOP', 'trd_trc_oce_alloc: failed to allocate arrays' )
       !
 # if defined key_trdmxl_trc
Index: /NEMO/trunk/src/TOP/trc.F90
===================================================================
--- /NEMO/trunk/src/TOP/trc.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trc.F90	(revision 10425)
@@ -141,5 +141,5 @@
       !!                    *** ROUTINE trc_alloc ***
       !!-------------------------------------------------------------------
-      USE lib_mpp, ONLY: ctl_warn
+      USE lib_mpp, ONLY: ctl_stop
       !!-------------------------------------------------------------------
       INTEGER :: ierr(4)
@@ -166,5 +166,5 @@
       ! 
       trc_alloc = MAXVAL( ierr )
-      IF( trc_alloc /= 0 )   CALL ctl_warn('trc_alloc: failed to allocate arrays')
+      IF( trc_alloc /= 0 )   CALL ctl_stop( 'STOP', 'trc_alloc: failed to allocate arrays' )
       !
    END FUNCTION trc_alloc
Index: /NEMO/trunk/src/TOP/trcbdy.F90
===================================================================
--- /NEMO/trunk/src/TOP/trcbdy.F90	(revision 10424)
+++ /NEMO/trunk/src/TOP/trcbdy.F90	(revision 10425)
@@ -71,5 +71,5 @@
             END SELECT
             ! Boundary points should be updated
-            CALL lbc_bdy_lnk( tra(:,:,:,jn), 'T', 1., ib_bdy )
+            CALL lbc_bdy_lnk( 'trcbdy', tra(:,:,:,jn), 'T', 1., ib_bdy )
             !
          END DO
